#!/usr/bin/perl 
use strict;
use JSON ;               
use CGI qw/:standard -nph/;
use LWP::UserAgent  ;
# use CGI::Carp  qw(warningsToBrowser fatalsToBrowser);  # comment when your done debuging.
use lib "/home/sdfrance/perl";

######### Global variables #########
my $graphit_net = 'graphitenet.magic.fr:8000';
my $cassandra_server_private_ip = '10.21.206.164';
my $grafananet_dash_dir = '/home/sdfrance/www/grafananet/app/dashboards';
my $grafananet_html_lists_dir = '/home/sdfrance/www/network' ;
my $main_index = 'kiss.magic.fr/index.php' ;
####################################

$| = 1;
my $r = shift;

print header;

my $magic_cookie = cookie("crowd.token_key");
my $login = cookie('login');

if ( $magic_cookie ) {

print start_html {
-head => meta({-name=>'viewport', -content=>'width=device-width, initial-scale=1'}),
-title => 'supressions de serveur du monitoring',
-style => [{-src=>'//code.jquery.com/ui/1.11.1/themes/smoothness/jquery-ui.css'},
           {-src=>'https://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap.min.css'},
           {-src => '/css/main.css'}
        ],
script=>[{-type=>'JAVASCRIPT', -src=>'//code.jquery.com/jquery-1.10.2.js'},
          {-type=>'JAVASCRIPT', -src=>'//code.jquery.com/ui/1.11.1/jquery-ui.js'},
          {-type=>'JAVASCRIPT', -src=>'https://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js'}
        ]
};

#Navigation
my $menu= "<nav class=\"navbar navbar-inverse navbar-fixed-top\" role=\"navigation\"><div class=\"navbar-header\">
            <div class=\"collapse navbar-collapse\">
                <ul class=\"nav navbar-nav navbar-left\">
                    <li class=\"dropdown\">
                        <a href=\"#\" class=\"dropdown-toggle\"  data-toggle=\"dropdown\"><span class=\"glyphicon glyphicon-align-justify\"></span></a>
                        <ul class=\"dropdown-menu\">
                            <li><a href=\"http://jira.hegerys.com/secure/ReleaseNote.jspa?projectId=10772&version=10202\"target=\"_blank\">Roadmap</a></li>
                            <li><a href=\"http://jira.hegerys.com/browse/XVBNQQ-49?jql=project%20%3D%20XVBNQQ\" target=\"_blank\">Bug Tracker</a></li>
                            <li><a href=\"https://astreinte.magiconline.fr\" target=\"_blank\">Astreintes</a></li>
                            <li><a href=\"https://deployer.magic.fr\" target=\"_blank\">Deployer</a></li>
                            <li><a href=\"https://casa:tHzf65TTn\@argus.magic.fr/cgi-bin/ew-argus?object=Top;func=page;top=1\" target=\"_blank\">Argus</a></li>
                        </ul>
                    </li>
                    <li><a href=\"../index.php\">MKISS</a></li>
                    <li><a href=\"../links.php\">Servers</a></li>
                    <li><a href=\"http://kiss.magic.fr:4567\" target=\"_blank\">Dashboard</a></li>
                    <li><a href=\"https://kiss.magic.fr:9443\" target=\"_blank\">Gridboard</a></li>
                    <li class=\"active\"><a href=\"cass.pl\">Purger</a></li> 
                </ul>
            </div>
        </div>
	<div class=\"collapse navbar-collapse\">
            <ul class=\"nav navbar-nav navbar-right\">
                <li><a href=\"http://confluence.hegerys.com/display/DTSH/Magic+Monitoring+-+KISS?src=contextnavchildmode\" target=\"_blank\">Documentation</a></li>
                <li><a href=\"#\" id=\"hide_button\">FAQ</a></li>
                <li><a href=\"mailto:alegrix\@magic.fr\">Contact</a></li>
                <li><a href=\"#\" id=\"about\">About</a></li>
         <li><a href=\"../deco.php\">$login<span class=\"glyphicon glyphicon-log-out\">&nbsp;</span></a></li>
            </ul>
            </div>
    </nav>";

print $menu;
#end Navigation

print "<div class='container'>" ;
print "<div class=\"jumbotron bord\" style=\"text-align:center;padding-top:5px;\"> <h1>Magic KISS NET Purger</h1>";
print p("Permet d'enlever un equipement reseau du stack monitoring, en purgeant ses metriques de la DB Cassandra," , "switchid = hostname dans les target de grafananet");
print p( {-class=>'warning'}, " N'utilisez pas cette page en cas de doute.") ;
print "</div>";

print div({-class=>'col-md-4'},
         start_form,
        span({-class=>'input-group', -style=>'margin-bottom: 10px'},
        span({-class=>'input-group-addon'},'Entrez le switchid '),
        textfield(-class=>'form-control', -name=>'name'),), 
        submit(-name=>'button_name_1',-value=>'envoyer', -class=>'btn btn-default'),
        end_form,
        hr);

print "<br clear=\"all\"/><br/>";
my  $x =  param('name') ;
chomp($x);
if (param('name') ne "" ) {
		 print   h3( {-class=>'tasks'}, " Verification de l'existance du switchid ..." ) , "\n" ;
		 $r->rflush; 
        my $url = 'http://' .  $graphite_net . '/metrics/expand?query=collectd.' . $x ;
        my $ua = LWP::UserAgent->new;
                $ua->timeout(30);
                $ua->env_proxy;
        my $content = $ua->get( $url );
        my $json = $content->decoded_content; 
        my $data = decode_json($json);
        my $name ;
        my $item = 0 ;

        if (defined ($name = $data->{'results'}->[$item] ) ) {
               my @result = split(/.*\.(.*)/, "$name") ;
                print "\n" , p ("Resultat de l'API : " , label(@result) )  , "\n" ; 
		$r->rflush ;		

 		print h3( {-class=>'tasks'}, 'extraction des paths pour ' , "$x"  ) ;
      		$r->rflush  ;
      		my $url = "http://" . $graphite_net  ."/metrics/expand?query=collectd.$x.snmp.*"   ;
      		my $url_ext = "http://" . $graphite_net . "/metrics/expand?query=collectd.$x.snmp.*.*"   ;
        	my $uaa = LWP::UserAgent->new ;
                $uaa->timeout(120) ;
                $uaa->env_proxy ;
       		my $content = $uaa->get(  "$url"  );
       		my $content_ext = $uaa->get(  "$url_ext"  );

		 my $json = $content->decoded_content;
		 my $json_ext = $content_ext->decoded_content;	

		 my $data = decode_json($json);
   		 my $data_ext = decode_json($json_ext);

     		 my $name ;
		 my $name_ext ;
      		 my @paths_list ;
      		 my $item = 0 ;
      		 my $item_ext = 0 ;

       		while  ( defined ($name_ext = $data_ext->{'results'}->[$item_ext] ) ) { push(@paths_list, $name_ext ); $item_ext++; }
     		while  ( defined ($name = $data->{'results'}->[$item] ) ) { push(@paths_list, $name ); $item++; }
		my $cqlsh_source = '/home/sdfrance/perl/' . $x . '.txt' ;
		if (-f $cqlsh_source ) {unlink $cqlsh_source;}
		open OUT, '>>', $cqlsh_source or die;
        	my @source ;
               foreach (@paths_list){
                        # my $dr10  =  "delete  from metric WHERE path='$_' AND rollup=10 AND period=60480 and tenant = '' ;" ."\n";
                        # push(@source, $dr10 );
                        my $dr300  =  "delete  from metric WHERE path='$_' AND rollup=300 AND period=60480 and tenant = '' ;" ."\n";
			push(@source, $dr300);
		        my $dr600 =  "delete  from metric WHERE path='$_' AND rollup=600 AND period=105120 and tenant = '' ;" . "\n";
                        push(@source, $dr600 );
                        }
		print OUT @source ;
        	close OUT;      			
        	print h3( {-class=>'tasks'}, 'Supression des metric pour ' , "$x"  ) ;
      		$r->rflush  ;
        		system("cqlsh -k metric $cassandra_server_private_ip -f $cqlsh_source") ;
			if (-f $cqlsh_source ) {unlink $cqlsh_source;}

                print h3( {-class=>'tasks'}, 'retrait de ' , "$x"  , 'de l\'API' ) ;
                $r->rflush  ;
                foreach (@paths_list){
			chomp $_ ;
			# print $_ ;
			my $curl = `curl -s -XDELETE \"$cassandra_server_private_ip:9200/cyanite_paths/path/$_\"`;
			# print  'here' ,  $curl ,  br ;
			}
			my $host = `curl -s -XDELETE \"$cassandra_server_private_ip:9200/cyanite_paths/path/collectd\.$x\"`;
			my $host_snmp = `curl -s -XDELETE \"$cassandra_server_private_ip:9200/cyanite_paths/path/collectd\.$x\.snmp\"`;


		print h3( {-class=>'tasks'}, "supression du template JSON..." ) ;
                $r->rflush  ;
			my $l = $grafananet_dash_dir . '/' . $x . '.json' ;
			if ( -e $l ) { unlink $l ; }	

			print h3( {-class=>'tasks'}, "supression du lien dans links ..." ) ;
			my $eqx_switches = $grafananet_html_lists_dir . '/eqx_switches.html' ;
			my $itx_switches = $grafananet_html_lists_dir . '/itx_switches.html';
			my $orn_switches = $grafananet_html_lists_dir . '/orn_switches.html';
			my $th2_switches = $grafananet_html_lists_dir . '/th2_switches.html';
			my @filenames = ( $eqx_switches , $itx_switches , $orn_switches, $th2_switches );
			if ($x eq "") { $x = 'a_bad_string_that_doesnt_exist' ;}
                        foreach my $filename (@filenames) {
			open IN, '<', $filename or die;
			my @content = <IN>;
			close IN;
			my @contents = grep(!/$x/, @content);
			open OUT, '>', $filename or die;
			print OUT @contents;
			close OUT;
			}
				print h3( {-class=>'tasks'}, "FIN DU JOB" ) ;
			} else {
        			print p({-class=>'content'}, 'Le switchid (' , $x , ') n\'est pas dans le stack monitoring');
				}    
			}	

print "\n</div>";
print "<br clear=\"all\"/><br> <div class=\"footer\">  <hr style=\"width:100%; border-top : 2px solid #c1c1c1\">  <p class=\"pull-right\"><a href=\"#\">Back to top</a></p>
      <p>&copy; 2014 Magic Online, Inc. &middot;  <a href=\"http://www.magic.fr\">Website</a> &middot; <a href=\"#\">Terms</a></p> </div>";
print end_html;
exit;

} else {
print "<META HTTP-EQUIV=refresh CONTENT=\"0;URL=http://$main_index\">\n";
}


